package com.bergerkiller.bukkit.nolagg.bufferedtag;

import java.io.DataInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import net.minecraft.server.NBTBase;
import net.minecraft.server.NBTTagList;

@SuppressWarnings({"rawtypes", "unchecked"})
public class NBTTagListBuffered extends NBTTagList {
	private List list;
	 
	public static NBTTagListBuffered readFrom(String name, final Map<String, byte[]> buffers, DataInputStream stream) throws IOException {
		NBTTagListBuffered rval = new NBTTagListBuffered(name);
		byte type = stream.readByte();
        int i = stream.readInt();
        rval.list = new ArrayList(i);

        for (int j = 0; j < i; ++j) {
            rval.list.add(NBTBaseBuffered.readFrom(type, null, buffers, stream));
        }
        
		return rval;
	}
	
	private NBTTagListBuffered(String name) {
		super(name);
	}

    public NBTBase get(int i) {
        return (NBTBase) this.list.get(i);
    }
    
    public int size() {
        return this.list.size();
    }
    
}
